function [ s_opt , x_opt, metric_opt] = M_PSK_sequence_detection_faster2( M, y)

N_RF = length(y);
M_PSK =  exp((1i*2*pi*[0:(M - 1)].')/M);
phi_cros = zeros(M/2,N_RF);
% sign_metric = zeros(M/2, N_RF);
% actual_phases = zeros(M/2, N_RF);
for n = 1 : N_RF
    for m = 1 : M/2
        phi_cros(m,n) = mod(atan(-tan(angle(y(n)) - (2*(m-1)+1)*pi/M )), 2*pi);
%         sign_metric(m,n) = sign(real(exp(phi_cros(m,n)) * y(n) * exp(-1i*(2*(m-1)+1)*pi/M) ) );
    end
end

phi_final = [];
n_final = [];
% count = 1;
% phi_cros
for n = 1 : N_RF
    for m = 1 : M/2
        if   0 < phi_cros(m,n) &&   phi_cros(m,n) <= 2*pi/M
            phi_final = [phi_final, phi_cros(m,n)];
           n_final = [n_final, n];
        end
    end
end
% phi_final
% 
[phi_sorted, ind_sorted] = sort(phi_final);
% n_final
% n_final(ind_sorted)
x_opt = zeros(1,N_RF);
%optimal phase at phi = 0;
for n = 1 : N_RF
    [~, m_opt] =  max( real(y(n) * (M_PSK)' ) );
    x_opt(n) = m_opt;
end
for n = 1 : N_RF
    s_opt(n) = M_PSK(x_opt(n));
end
metric_complex_opt =  y * s_opt';

metric_opt = abs(metric_complex_opt);

x_cur = x_opt;

M_cal = [1:M];
for i = 1 : length(phi_sorted)
   
    n =  n_final(1,ind_sorted(i));
%     m_cur =  m_n_final(2,ind_sorted(i))
%     i
% n
    cur_metric_real_n = -inf;

    metric_complex_opt = metric_complex_opt - M_PSK(x_cur(n))'*y(n); 
    M_cal_except_x_cur = setdiff(M_cal,x_cur(n));
    for m = M_cal_except_x_cur
        tmp = real(M_PSK(m)'*y(n)*exp(1i*phi_sorted(i)) );
        if(tmp > cur_metric_real_n)
           cur_metric_real_n = tmp;
           x_cur(n) = m ;
        end
    end


    metric_complex_opt = metric_complex_opt + M_PSK(x_cur(n))'*y(n); 
    
    cur_metric = abs(metric_complex_opt);
     
    if cur_metric >= metric_opt
       x_opt = x_cur ;
       metric_opt = cur_metric;
    end
end 
for n = 1 : N_RF
    s_opt(n) = M_PSK(x_opt(n));
end

end

